;DrawFormatText V1.10
;
;Create : 11 Juin 2012
;Update : 23 Juin 2012
;
;OS : Window, Linux, OSx
;PB 4.51 et plus
;
;
;Contributors
; Falsam
;
;
;Licence : Use As You Like
;
;Cette procdure reoit un texte  formater et  imprimer sur une zone d'impression.
;
;La zone d'impression
; Left      - Marge gauche
; Top       - Marge haute
; Width     - Largeur de la zone d'impression
; Height    - Hauteur de la zone d'impression
; 
;Texte
; Text      - Texte brute  imprimer. Il peut comprend les caracteres de passage  la ligne.
; TextColor - Couleur du texte
; Justify   - ALigner  gauche (0), droite (1), Centr (2), Justifi gauche et droite (3). Defaut 0
; padding   - Marge intrieur haut, bas, gauche et droite de la zone d'impression. Defaut 5Px
; La justification gauche droite n'est pas encore fonctionnelle
;

Procedure DrawFormatText(Left, Top, Width, Height, Text.s, TextColor.l, Justify.i=0, Padding=5)
  Protected N.i, W.i, X.i, Y.i, Buffer.s, Process.i, WordWidth.i
  
  ;Liste des mots pour une ligne
  Structure DefWord
    SpaceBefore.i         ;Espace avant le mot
    Word.s                ;Mot 
    X.i                   ;Coordonne X sur l'image
    Y.i                   ;Coordonne Y dans l'image
    WordWidth.i           ;Largeur du mot dessin
  EndStructure
  
  ;Liste des phrases 
  Structure DefSentence
    Sentence.s            ;Phrase
    CountInterval.i       ;Nombre d'interval
    FreeSpaces.i          ;Espace libre (permet le calcul d'un interval)
    IntervalSize.i        ;Taille d'un interval
    LineHeight.i          ;Hauteur d'une ligne
    List Words.Defword()  ;Liste de mots composant la phrase
  EndStructure
  
  Protected NewList Sentences.defsentence(), *Memory.defsentence
  
  
  ;j'ai un soucis d'affichage avec les #CRLF$ et je suis oblig de mettre en place une astuce qui ne me plait pas 
  
  ;Retirer les caractres LF (Line Feed) 
  Text = RemoveString(Text, #LF$)
  
  ;remplacer les #CR$ (Carriage Return) par un "|"
  ReplaceString(Text, #CR$,"|",#PB_String_InPlace)
  
  ;Chaque ligne est maintenant dlimite par un "|"
  ;On commence par mmoriser chaque ligne
  For N=1 To CountString(Text, "|")+1
    
    ;Mmorisation de chaque ligne
    AddElement(Sentences())
    Sentences()\Sentence = StringField(Text, N, "|")
    
    ;Pour chaque ligne, calcul du nombre d'intervals
    Sentences()\CountInterval = CountString(Sentences()\Sentence, " ")
    
    ;Mmorisation de la hauteur de ligne (Permet de savoir ou se positionne la ligne suivante)
    Sentences()\LineHeight = TextHeight(Sentences()\Sentence)+4
    
    ;Pour chaque ligne, stockage de chaque mot
    For W=1 To CountString(Sentences()\Sentence, " ")+1
      AddElement(Sentences()\Words())
      
      Sentences()\Words()\SpaceBefore = TextWidth(Space(1)) ;largeur d'un espace entre chaque mot
      Sentences()\Words()\Word = StringField(Sentences()\Sentence, W, " ") ;Mmorisation du mot
      Sentences()\Words()\WordWidth = TextWidth(Sentences()\Words()\Word) ;Largeur dessin du mot
    Next    
    
    ;largeur de chaque interval : Minimum un espace
    If Sentences()\CountInterval<>0
      Sentences()\IntervalSize = Width / Sentences()\CountInterval
      If Sentences()\IntervalSize < TextWidth(Space(1))
        Sentences()\IntervalSize = TextWidth(Space(1))
      EndIf
    EndIf
  Next  
  ;Fin de la lectures les lignes  dssiner 
  
  ;Comment est justifi le texte 
  Select Justify  
    Case 0 ;Texte  gauche : On imprimera une ligne entire
      
      ;Initialisation de la marge gauche et haut 
      X = Left + Padding + 1 
      Y = Top + Padding + 1
      
      ;Pour chaque phrase on calcule les coordonnes X,Y de chaque mot avant impression
      ForEach Sentences()        
        ForEach Sentences()\Words()
          Sentences()\Words()\X = X
          Sentences()\Words()\Y = Y
          
          ;WordWith permet de connaitre la largeur total de la ligne apres ajout de la largeur d'un mot.
          WordWidth = Sentences()\Words()\SpaceBefore + Sentences()\Words()\WordWidth
          
          ;On connait la position x du prochain mot
          X = X + WordWidth
          
          ;Si X est suprieur  la largeur de l'impression + les marges
          ;le mot en cours de lecture passera  la ligne
          If X > (Left + Width-Padding*2)
            X = Left + Padding ;Retour  la ligne
            Y = Y + Sentences()\LineHeight
            Sentences()\Words()\X = X
            Sentences()\Words()\Y = Y
            
            WordWidth = Sentences()\Words()\WordWidth
            X = X + WordWidth
          EndIf    
        Next
        
        ;Lecture d'une nouvelle ligne. Changement de ligne
        X = Left + Padding
        Y = Y + Sentences()\LineHeight    
      Next
      ;Chaque mot est maintenant bien plac
      
      ;Impression des lignes 
      Y=0 
      ForEach Sentences() ;Pour chaque ligne        
        ForEach Sentences()\Words() ;Pour chaque mot
          
          ;Si la position Y du mot est differents de la position Y du mot prcdent
          If Y <> Sentences()\Words()\Y 
            X=Sentences()\Words()\X ;Nouvelle position X
            
            ;Si la position Y n'est pas plus grande que la hauteur de la zone d'impression
            If Sentences()\Words()\Y < Top + Height - Padding*2
              DrawText(X, Y, Buffer, TextColor) ;Alors impression de la ligne
              Y=Sentences()\Words()\Y ;Mmorisation de la position Y de la ligne en cours 
            EndIf
            
            Buffer="" ;On change de ligne. RAZ du buffer
          EndIf
          
          Buffer+Sentences()\Words()\Word+" " ;On ajoute le mot au buffer
        Next
        
        If Len(Trim(Buffer))>0
          If Sentences()\Words()\Y < Top + Height - Padding*2
            DrawText(X, Y, Buffer, TextColor)
          EndIf
        EndIf        
      Next
      
      
    Case 1 ;Texte  droite
      ;Initialisation de la marge gauche et haut
      X = Left + Padding + 1
      Y = Top + Padding + 1
      
      ;Pour chaque phrase on calcule les coordonnes X,Y de chaque mot avant impression
      ForEach Sentences()        
        ForEach Sentences()\Words()
          Sentences()\Words()\X = X
          Sentences()\Words()\Y = Y
          
          ;WordWith permet de connaitre la largeur total de la ligne apres ajout de la largeur d'un mot.
          WordWidth = Sentences()\Words()\SpaceBefore + Sentences()\Words()\WordWidth
          
          ;On connait la position x du prochain mot
          X = X + WordWidth
          
          ;Si X est suprieur  la largeur de l'impression + les marges
          ;le mot en cours de lecture passera  la ligne
          If X > Left + Width - Padding*2
            X = Left + Padding ;Retour  la ligne
            Y = Y + Sentences()\LineHeight
            Sentences()\Words()\X = X
            Sentences()\Words()\Y = Y
            
            WordWidth = Sentences()\Words()\SpaceBefore + Sentences()\Words()\WordWidth
            X = X + WordWidth
          EndIf    
        Next
        
        ;Lecture d'une nouvelle ligne. Changement de ligne
        X = Left + Padding
        Y = Y + Sentences()\LineHeight   
      Next
      ;Chaque mot est maintenant bien plac
      
      ;Impression des lignes 
      Y=0
      ForEach Sentences()
        ForEach Sentences()\Words()
          If Y<>Sentences()\Words()\Y
            X=Sentences()\Words()\X-TextWidth(Space(2))
            If Sentences()\Words()\Y < Top + Height - Padding*2
              DrawText(Left+Width-Padding*2 - TextWidth(Trim(Buffer)), Y, Buffer, TextColor)
              Y=Sentences()\Words()\Y
            EndIf
            Buffer=""
          EndIf
          Buffer+Sentences()\Words()\Word+" "
        Next
        If Len(Trim(Buffer))>0
          If Sentences()\Words()\Y < Top + Height - Padding*2
            DrawText(Left+Width-Padding*2 - TextWidth(Trim(Buffer)), Y, Buffer, TextColor)
          EndIf
        EndIf        
      Next
      
    Case 2 ;Centr
      ;Initialisation de la marge gauche et haut
      X = Left + Padding + 1
      Y = Top + Padding + 1
      
      ;Pour chaque phrase on calcule les coordonnes X,Y de chaque mot avant impression
      ForEach Sentences()        
        ForEach Sentences()\Words()
          Sentences()\Words()\X = X
          Sentences()\Words()\Y = Y
          
          ;WordWith permet de connaitre la largeur total de la ligne apres ajout de la largeur d'un mot.
          WordWidth = Sentences()\Words()\SpaceBefore + Sentences()\Words()\WordWidth
          
          ;On connait la position x du prochain mot
          X = X + WordWidth
          
          If X > (Left + Width - Padding*2)
            X = Left + Padding ;Retour  la ligne
            Y = Y + Sentences()\LineHeight
            Sentences()\Words()\X = X
            Sentences()\Words()\Y = Y
            
            WordWidth = Sentences()\Words()\SpaceBefore + Sentences()\Words()\WordWidth
            X = X + WordWidth
          EndIf    
        Next
        
        ;Lecture d'une nouvelle ligne. Changement de ligne
        X = Left + Padding
        Y = Y + Sentences()\LineHeight+Padding ;Plus Padding pour le changement de paragraphe      
      Next
      ;Chaque mot est maintenant bien plac
      
      ;Impression des lignes 
      Y=0
      ForEach Sentences()
        ForEach Sentences()\Words()
          If Y<>Sentences()\Words()\Y
            If Sentences()\Words()\Y < Top + Height - Padding*2
              DrawText(Left + (Width - TextWidth(Trim(Buffer)))/2, Y, Buffer, TextColor)
              Y=Sentences()\Words()\Y
            EndIf
            Buffer=""
          EndIf
          Buffer+Sentences()\Words()\Word+" "
        Next
        If Len(Trim(Buffer))>0
          If Sentences()\Words()\Y < Top + Height - Padding*2
            DrawText(Left + (Width - TextWidth(Trim(Buffer)))/2, Y, Buffer, TextColor)
          EndIf
        EndIf        
      Next
      
      
    Case 3 ;Justifi gauche et droite (Problme d'affichage  corriger)
      X = Left + Padding
      Y = Top + Padding

      ForEach Sentences()        
        ForEach Sentences()\Words()
                   
          Sentences()\Words()\X = X
          Sentences()\Words()\Y = Y
          
          WordWidth = Sentences()\IntervalSize + Sentences()\Words()\WordWidth
          X = X + WordWidth
        
          If X > (Left + Width - Padding*2)
           
            ;Passage  la ligne 
            X = Left + Padding ;Retour  la ligne
            Y = Y + Sentences()\LineHeight
            Sentences()\Words()\X = X
            Sentences()\Words()\Y = Y
            
            ;Correction de l'avant dernier mot
            *Memory\Words()\X = Left+width - *memory\Words()\WordWidth
                
          EndIf
          *Memory=@Sentences()
        Next
        
        ;Lecture d'une nouvelle ligne. Changement de ligne
        X = Left + Padding
        Y = Y + Sentences()\LineHeight+Padding ;Plus Padding pour le changement de paragraphe      
      Next
      
      ;Impression des lignes 
      ForEach Sentences()
        ForEach Sentences()\Words()
          If Sentences()\Words()\Y < Top + Height
            DrawText(Sentences()\Words()\X , Sentences()\Words()\Y, Sentences()\Words()\Word, TextColor)
          EndIf
        Next
      Next
     
  EndSelect  
EndProcedure
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 70
; FirstLine = 27
; Folding = ----
; Markers = 106,178
; EnableXP